<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;

class RelatoriosVendaProduto {
    
    
    protected $RelatoriosVendaProdutoServices;
    protected $utilService;

    public function __construct (Services\RelatoriosVendaProduto $RelatoriosVendaProdutoServices, Utilities\Util $utilService) {
        $this->RelatoriosVendaProdutoServices = $RelatoriosVendaProdutoServices;
        $this->utilService = $utilService;
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        set_time_limit(120);
        $conditions = $this->utilService->getParamsAsArray($request);
        $tipoRelatorio = $conditions['TIPORELATORIO'];
        unset($conditions['TIPORELATORIO']);

        $modalidades = 'MES_BAL_DLV_TAA_CMD_AJU_AUT';
    
        if(array_key_exists('MODALIDADE2', $conditions))
            $conditions['MODALIDADE'] = $conditions['MODALIDADE2'];
    
        $conditions = $this->RelatoriosVendaProdutoServices->buildParamsFaturamento($conditions, $modalidades);

        if($tipoRelatorio == 'A') {
            $result = $this->RelatoriosVendaProdutoServices->findAnalitico($conditions);
        } elseif($tipoRelatorio == 'S') {
            $result = $this->RelatoriosVendaProdutoServices->findSintetico($conditions);
        } else {
            $result = $this->RelatoriosVendaProdutoServices->findData($conditions);
        }
        
        $response->addDataSet(new DataSet("vnd41201_relVendaProdutoAnalitico", $result));
    }
}